﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Numerics;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TelemetryIO
{
    public partial class TestQuaternion : UserControl
    {
        private float[] rates = new float[3];
        private Quaternion attitude = new Quaternion(0, 0, 0, 1);
        public TestQuaternion()
        {
            InitializeComponent();
        }

        private void updateWithAngularRates()
        {
            Quaternion wq = new Quaternion(rates[0], rates[1], rates[2], 0);
            //wq *= 0.5f;
            attitude = attitude * wq;
            attitude = attitude*(1 / attitude.Length());
        }

        private void ROLL_track_Scroll(object sender, EventArgs e)
        {
            TrackBar tb = sender as TrackBar;
            rates[0] = (float)(tb.Value)/180f*(float)Math.PI/2;
            updateWithAngularRates();
            updateView();
        }

        private void PITCH_track_Scroll(object sender, EventArgs e)
        {
            TrackBar tb = sender as TrackBar;
            rates[1] = (float)(tb.Value) / 180f * (float)Math.PI/2;
            updateWithAngularRates();
            updateView();
        }

        private void YAW_track_Scroll(object sender, EventArgs e)
        {
            TrackBar tb = sender as TrackBar;
            rates[2] = (float)(tb.Value) / 180f * (float)Math.PI/2;
            updateWithAngularRates();
            updateView();
        }

        private void updateView()
        {
            if (Qw_label.InvokeRequired)
            {
                Qw_label.Invoke(new Action(()=> Qw_label.Text = attitude.W.ToString("0.000")));
            }
            else
            {
                Qw_label.Text = attitude.W.ToString("0.000");
            }

            if (Qx_label.InvokeRequired)
            {
                Qx_label.Invoke(new Action(() => Qx_label.Text = attitude.X.ToString("0.000")));
            }
            else
            {
                Qx_label.Text = attitude.X.ToString("0.000");
            }

            if (Qy_label.InvokeRequired)
            {
                Qy_label.Invoke(new Action(() => Qy_label.Text = attitude.Y.ToString("0.000")));
            }
            else
            {
                Qy_label.Text = attitude.Y.ToString("0.000");
            }

            if (Qz_label.InvokeRequired)
            {
                Qz_label.Invoke(new Action(() => Qz_label.Text = attitude.Z.ToString("0.000")));
            }
            else
            {
                Qz_label.Text = attitude.Z.ToString("0.000");
            }

            if (ROLL_label.InvokeRequired)
            {
                ROLL_label.Invoke(new Action(() => ROLL_label.Text = rates[0].ToString("0.00")));
            }
            else
            {
                ROLL_label.Text = rates[0].ToString("0.00");
            }

            if (PITCH_label.InvokeRequired)
            {
                PITCH_label.Invoke(new Action(() => PITCH_label.Text = rates[1].ToString("0.00")));
            }
            else
            {
                PITCH_label.Text = rates[1].ToString("0.00");
            }

            if (YAW_label.InvokeRequired)
            {
                YAW_label.Invoke(new Action(() => YAW_label.Text = rates[2].ToString("0.00")));
            }
            else
            {
                YAW_label.Text = rates[2].ToString("0.00");
            }
        }

        private void Reset_quaternion_Click(object sender, EventArgs e)
        {
            attitude = new Quaternion(0, 0, 0, 1);
            updateView();
        }
    }
}
